%TITLE          "稪 GlukOS"
                IDEAL
                MODEL   tiny
                DATASEG
KernelSeg       EQU 01000h

color           DB 01Fh
string          DB "Welcome to GlukOS v.01",0
loading         DB "System now loading... please wait...",0

BytesPerRowa=80*2
rowa=0
LABEL   ScRow Word
REPT    25
DW      (rowa*BytesPerRowa)
rowa=rowa+1
ENDM

                CODESEG
                ORG     100h    ;   boot ᥪ   
Start:          jmp     Start1  ; 0000:7C00, ᫥⥫쭮   
                ORG     07C00h  ;   .
Start1:         jmp     Begin
                ; EB 3C 90
                ;         ᮢ⨬  DOS
                nop
OEMName         DB      29h,63h,7Eh,26h,49h,49h,48h,43h
SectSize        DW      00200h
ClustSize       DB      001h
ResSecs         DW      00001h
FatCnt          DB      002h
RootSiz         DW      000E0h
TotSecs         DW      00B40h
Media           DB      0F0h
FatSize         DW      00009h
TrkSecs         DW      00012h
HeadCnt         DW      00002h
HidnSec         DW      00000h
;  ६
AbsSectNum      DW      0
AbsHeadNum      DW      0

Begin:          ; 
                mov     cx,00101h
                mov     dx,0164Dh
                call    Ramka
                ; 뢮 ப
                lea     si,[String]
                mov     dx,031Ch
                call    print
                ; 뢮 ப
                lea     si,[loading]
                mov     dx,0503h
                call    print
                ; ⠥ 
                mov     ax,KernelSEG
                mov     es,ax
                mov     di,100h          ; Entry Point - KernelSEG:100h
                mov     dx,33            ;  ᥪ  묨 (128 ᥪ஢ )
nextsect:       push    dx es di
                call    ReadSect
                pop     di es dx
                add     di,512
                inc     dx
                cmp     dx,160
                jne     nextsect
                call     far KernelSEG:0100h
                ; ReadKey
                int     20h
; ⥭ ᥪ (DX= ᥪ) ##########################################
; ES:DI - 㤠 
PROC            ReadSect
                push di es
                 ; 砫  ᥪ/஦/
                 push    cs
                 pop     ds
                 mov     cx,[TrkSecs]
                 mov     si,dx
                 ; tmp=(Sect/Sectors);
                 mov     ax,si
                 xor     dx,dx
                 div     cx
                 mov     di,ax
                 ; Sec=Sect-(tmp*Sectors)+1;
                 mov     ax,di
                 imul    cx
                 mov     dx,si
                 sub     dx,ax
                 inc     dx
                 mov     [AbsSectNum],dx
                 ; Hea=tmp & 1;
                 mov     ax,di
                 and     ax,1
                 mov     [AbsHeadNum],ax
                 ; Trk=(Sect-(Hea*Sectors)-(Sec-1))/(Sectors*2);
                 imul    cx
                 push    ax
                 mov     ax,si
                 pop     dx
                 sub     ax,dx
                 mov     dx,[AbsSectNum]
                 dec     dx
                 sub     ax,dx
                 mov     dx,cx
                 shl     dx,1
                 push    ax
                 push    dx
                 xor     dx,dx
                 pop     bx
                 pop     ax
                 div     bx           ; AX = AbsTrackNum
                 ;  ⮢
                 mov     cx,ax
                 mov     al,cl
                 shr     cx,2
                 and     cl,0C0h
                 mov     ch,al
                 and     cx,0FFC0h
                 mov     ax,[AbsSectNum]  ;      5432109876543210
                 or      cl,al            ; CX =  c c c c c c c c C c S s s s s s
                pop     es bx             ; ES:BX = 㤠 뢠
                mov     dx,[AbsHeadNum]
                mov     dh,dl             ;  
                mov     dl,0              ;  ᪠ 0 = A
                mov     al,1              ; ⢮ 뢠 ᥪ஢
                mov     ah,2              ;  㭪樨
                int     13h
                ret
ENDP            ReadSect
; 뢮 ப ds:di #########################################################
PROC            print
                mov   ax,0B800h
                mov   es,ax
                call  SetVidAddr
print1:         mov   ah,[Color]
                mov   al,[ds:si]
                or    al,al
                je    prnend
                mov   [es:di],ax
                inc   di
                inc   di
                inc   si
                jmp   print1
prnend:         ret
ENDP            print
; ⠭   ##############################################
PROC            SetVidAddr                 ;⮢  .
                xor     bh, bh             ;dx - न
                mov     bl, dh             ;  di 
                shl     bx, 1
                mov     di, [ScRow+bx]
                xor     dh, dh
                shl     dx, 1
                add     di, dx
                ret
ENDP            SetVidAddr
;  ######################################################################
Ramka:          mov     ax,0B800h
                mov     es,ax
                or      dl,dl                   ; [ch] -  Y   [cl] -  X
                je      RamkaEnd                ; [dh] - Y   [dl] - X
                or      dh,dh
                je      RamkaEnd
                mov     ah,[Color]
                dec     dl
                dec     dh
                xor     bh,bh
                mov     bl,ch
                push    dx ax
                 mov     dx,160
                 mov     ax,bx
                 mul     dx
                 mov     bx,ax
                pop     ax dx
                xor     ch,ch
                shl     cx,1
                add     bx,cx
                mov     di,bx                   ;[di] -  孥-
                push    di
                mov     al,""
                stosw
                mov     al,""
                xor     ch,ch
                mov     cl,dl
                rep     stosw
                mov     al,""
                stosw
                pop     di
                mov     cl,dh
                xor     ch,ch
Ramka_1:        add     di,160
                push    di
                push    cx
                mov     al,""
                stosw
                mov     al," "
                xor     ch,ch
                mov     cl,dl
                rep     stosw
                mov     al,""
                stosw
                pop     cx
                pop     di
                loop    Ramka_1
                add     di,160
                mov     al,""
                stosw
                mov     al,""
                xor     ch,ch
                mov     cl,dl
                rep     stosw
                mov     al,""
                stosw
RamkaEnd:       ret
                END     Start
